Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
Botan::SRP6_Server_Session Class Reference

`#include <srp6.h>`

## Public Member Functions
BigInt | step1 (const BigInt &v, const std::string &group_id, const std::string &hash_id, RandomNumberGenerator &rng)
SymmetricKey | step2 (const BigInt &A)

## Detailed Description

Represents a SRP-6a server session

Definition at line 66 of file srp6.h.

## Member Function Documentation

BigInt Botan::SRP6_Server_Session::step1 | ( | const BigInt & | v,
|  | const std::string & | group_id,
|  | const std::string & | hash_id,
|  | RandomNumberGenerator & | rng
| ) |  |

Server side step 1

Parameters

  v | the verification value saved from client registration
  group_id | the SRP group id
  hash_id | the SRP hash in use
  rng | a random number generator

Returns
  SRP-6 B value

Definition at line 122 of file srp6.cpp.

References Botan::BigInt::bytes(), Botan::DL_Group::get_g(), Botan::DL_Group::get_p(), and Botan::power_mod().

126 {
127 DL_Group group(group_id);
128 const BigInt& g = group.get_g();
129 const BigInt& p = group.get_p();
130
131 m_p_bytes = p.bytes();
132 m_v = v;
133 m_b = BigInt(rng, 256);
134 m_p = p;
135 m_hash_id = hash_id;
136
137 const BigInt k = hash_seq(hash_id, m_p_bytes, p, g);
138
139 m_B = (v*k + power_mod(g, m_b, p)) % p;
140
141 return m_B;
142 }
Botan::power_mod
BigInt power_mod(const BigInt &base, const BigInt &exp, const BigInt &mod)
Definition: numthry.cpp:373

SymmetricKey Botan::SRP6_Server_Session::step2 | ( | const BigInt & | A | ) |

Server side step 2

Parameters

  A | the client's value

Returns
  shared symmetric key

Definition at line 144 of file srp6.cpp.

References Botan::BigInt::encode_1363(), and Botan::power_mod().

Referenced by Botan::TLS::Client_Key_Exchange::Client_Key_Exchange().

145 {
146 if(A <= 0 || A >= m_p)
147 throw Exception("Invalid SRP parameter from client");
148
149 const BigInt u = hash_seq(m_hash_id, m_p_bytes, A, m_B);
150
151 const BigInt S = power_mod(A * power_mod(m_v, u, m_p), m_b, m_p);
152
153 return BigInt::encode_1363(S, m_p_bytes);
154 }
Botan::power_mod
BigInt power_mod(const BigInt &base, const BigInt &exp, const BigInt &mod)
Definition: numthry.cpp:373
Botan::BigInt::encode_1363
static secure_vector< uint8_t > encode_1363(const BigInt &n, size_t bytes)
Definition: big_code.cpp:82

The documentation for this class was generated from the following files:

- src/lib/misc/srp6/srp6.h
- src/lib/misc/srp6/srp6.cpp